#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Shared;

namespace EssentialPDFSamples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label1;
		private DataTable dTable;
		private bool headerPublished = true;
	    private PDFTemplateArea gheader;
        private string headerText;
        PDFDocument pdfDoc = new PDFDocument();
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.Image = ((System.Drawing.Bitmap)(resources.GetObject("button1.Image")));
			this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.button1.Location = new System.Drawing.Point(464, 72);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "PDF";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.label1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(544, 56);
			this.label1.TabIndex = 1;
			this.label1.Text = @"Clicking the button below will result in a new PDF document being generated using Essential PDF.  At the end of the document generation, an option will be provided to view the generated PDF file. Please note that you need to have a PDF viewer installed in order to view the generated PDF file.";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 102);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.button1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Essential PDF Sample";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{

			this.Cursor = Cursors.WaitCursor;


			gheader = null;

			//Create DataTable
			dTable = this.GetTable(100,5);
			pdfDoc.LastPage.Orientation = PageOrientation.Landscape;

			pdfDoc.PageCreated += new PageCreatedEventHandler ( pdfDoc_PageCreated );
            headerText = "Essential PDF Demo";
			AddHeader ( pdfDoc, headerText, "HeaderAndFooter Demo Sample" );
			AddFooter ( pdfDoc, false );

		   	//Adding a font that can be used to draw Text inside the PDF document.
			//Using the Predefined fonts to draw the text. 
			IPDFFont pdfFont = pdfDoc.Fonts.Add( FontBaseFamily.Courier );
		    
			//Accessing the first page in the pages collection.
			IPDFPage firstPage = pdfDoc.Pages[0];
			
			//Create a new PDF Table.
			ITable table = pdfDoc.CreateTable();

			//Setting Table properties.
			table.PublishHeader = true;
			table.PageBreakBehavior = AutoBreakBehavior.FullBreak;

			//Subscribing to Table publishing events.
			table.CreateColumns +=new CreateColumnsEventHandler(table_CreateColumns);
			table.CreateHeaderRow +=new CreateRowEventHandler(table_CreateHeaderRow);
			table.CreateRow +=new CreateRowEventHandler(table_CreateRow);
			table.BeforeTablePublishing +=new BeforeTablePublishingEventHandler(table_BeforeTablePublishing);

			this.Cursor = Cursors.Arrow;

		    //---Publish the table
			table.Publish ( new PointF ( 0, 0 ), pdfDoc.LastPage );

			pdfDoc.CreatePage ();
            headerText = "New PDF Demo";
			AddHeader ( pdfDoc, headerText, "Header And Footer Demo" );
			AddFooter ( pdfDoc, false );

			rowCounter = 0;
			table.ImportDataTable ( GetTable ( 50, 10 ), false );

			table.Publish ( new PointF ( 0, 0 ), pdfDoc.LastPage );
		    		    
			//Save the PDF Document to disk.
			pdfDoc.Save("Sample.pdf");
			
			//Message box confirmation to view the created PDF document.
			if (MessageBox.Show ("Do you want to view the PDF file?", "PDF File Created",
				MessageBoxButtons.YesNo, MessageBoxIcon.Information)
				== DialogResult.Yes) 
			{
				//Launching the PDF file using the default Application.[Acrobat Reader]
				System.Diagnostics.Process.Start("Sample.pdf");
			}
			else
			{
				// Exit
				this.Close();
			}
		}

	    void pdfDoc_PageCreated ( object sender, PageCreatedEventArgs args )
        {
                           
                AddHeader(pdfDoc, headerText, "HeaderAndFooter Demo Sample");
                        
	    }

		private void AddHeader ( PDFDocument doc, string title, string description )
		{
		    if ( doc == null )
		    {
			   throw new ArgumentNullException ( "doc" );
		    }

		    if ( title == null )
		    {
			   throw new ArgumentNullException ( "title" );
		    }

		    int offset = 10;

		    // Last version
		    PDFTemplateArea header = doc.Templates.Add (
			    new SizeF ( doc.LastPage.DrawingWidth, 80 ) );
		    header.Dock = PDFDockStyle.Top;
		    IPDFFont font = doc.Fonts.Add ( FontBaseFamily.HelveticaBold );
		    font.Size = 24;
		    float doubleHeight = font.Height * 2;
		    Color activeColor = Color.FromArgb ( 44, 71, 120 );

		    // add logo
		    IPDFGraphicState props = doc.CreateGraphicState ( );
		    SizeF imageSize = new SizeF ( 100, 50 );
		    PointF imageLocation = new PointF ( doc.LastPage.DrawingWidth - imageSize.Width, 15 );
		    props.Padding = new PDFPadding ( offset, offset, 0, 0 );
		   
		    // add title tag
		    props = doc.CreateGraphicState ( );
		    props.TextAlignment = TextAlignment.Center;
		    props.ForeColor = activeColor;
		    
		    font.Size -= 4;
		    props.Padding = new PDFPadding ( offset * 2, 0, ( int ) imageSize.Width, 0 );
		    header.Graphics.DrawMultiText ( offset, 5, doc.LastPage.DrawingWidth, font.Height,
			    title, font, props );

		    SizeF headerSize;
		    // add description tag
		    if ( description != null && description.Length > 0 )
		    {
			   headerSize = header.Size;
			   font = doc.Fonts.Add ( FontBaseFamily.HelveticaOblique );
			   font.Size = 8;
			   props = doc.CreateGraphicState ( );
			   props.TextAlignment = TextAlignment.Left;
			   props.Padding = new PDFPadding ( offset, 0, 0, 0 );
			   props.ForeColor = Color.Gray;
			   header.Graphics.DrawMultiText ( 0, 50,
				   doc.LastPage.DrawingWidth, font.Height, description, font, props );
		    }

		    // add border effect
		    float width = doc.LastPage.DrawingWidth;

		    headerSize = header.Size;
		    headerSize.Height -= 10;
		    activeColor = Color.FromArgb ( 139, 164, 204 );

		    props = doc.CreateGraphicState ( );
		    props.ForeColor = activeColor;
		    header.Graphics.DrawLine ( 0, 0, width, 0 );
		    header.Graphics.DrawLine ( 0, headerSize.Height, width, headerSize.Height );

		    props = doc.CreateGraphicState ( );
		    props.LineWidth = 2;
		    props.ForeColor = activeColor;
		    header.Graphics.DrawLine ( 0, 2, width, 2, props );
		    header.Graphics.DrawLine ( 0, headerSize.Height - 2, width, headerSize.Height - 2, props );

		    header.Graphics.DrawLine ( 0, 5, width, 5 );
		    header.Graphics.DrawLine ( 0, headerSize.Height - 5, width, headerSize.Height - 5 );

		   doc.LastPage.Header = header;
		    gheader = header;
		}


		private void AddFooter ( PDFDocument doc, bool isLeftRightBarPresents )
		{
		    if ( doc == null )
		    {
			   throw new ArgumentNullException ( "doc" );
		    }

		    PDFTemplateArea footer = doc.Templates.Add ( new SizeF (
			    doc.LastPage.DrawingWidth, 40 ) );

		    IPDFFont font = doc.Fonts.Add ( FontBaseFamily.HelveticaBold );
		    font.Size = 10;
		    string text = "Copyright 2005 - Page #p;";
		    SizeF size = footer.Graphics.MeasureString ( text, font );
		    RectangleF bounds = new RectangleF ( 0, 15,
			    footer.Size.Width, footer.Size.Height );
		    IPDFGraphicState props = doc.CreateGraphicState ( );
		    props.TextAlignment = TextAlignment.Right;
		    props.BreakBehavior = AutoBreakBehavior.Cropping;

		    footer.Graphics.DrawMultiText ( bounds, text, font, props );

		    props = doc.CreateGraphicState ( );
		    props.ForeColor = Color.Gray;
		    IPDFFont textFont = doc.Fonts.Add ( FontBaseFamily.HelveticaOblique );
		    textFont.Size = 8;
		    props.BreakBehavior = AutoBreakBehavior.Cropping;

		    float width = doc.LastPage.DrawingWidth;

		    footer.Graphics.DrawText ( 8, 15, "Syncfusion Inc. PDF Generation Example.", textFont, props );

		    // add border effect on demand
		    if ( isLeftRightBarPresents )
		    {
			   SizeF footerSize = footer.Size;
			   footerSize.Height -= 10;

			   Color activeColor = Color.FromArgb ( 139, 164, 204 );

			   props = doc.CreateGraphicState ( );
			   props.ForeColor = activeColor;
			   footer.Graphics.DrawLine ( 0, 0, width, 0 );
			   footer.Graphics.DrawLine ( 0, footerSize.Height, width, footerSize.Height );

			   props = doc.CreateGraphicState ( );
			   props.LineWidth = 2;
			   props.ForeColor = activeColor;
			   footer.Graphics.DrawLine ( 0, 2, width, 2, props );
			   footer.Graphics.DrawLine ( 0, footerSize.Height - 2, width, footerSize.Height - 2, props );

			   footer.Graphics.DrawLine ( 0, 5, width, 5 );
			   footer.Graphics.DrawLine ( 0, footerSize.Height - 5, width, footerSize.Height - 5 );
		    }

		    doc.Templates.Footer = footer;
		}
		private DataTable GetTable(int row, int col)
		{
			DataTable dt = new DataTable("MyTable");

			int nCols = col;
			int nRows = row;

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn("Header"+ i.ToString()));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					dr[j] = i.ToString()+ "," +j.ToString();
				dt.Rows.Add(dr);
			}
			return dt;
		}

		private void table_CreateColumns(object sender, CreateColumnsEventArgs args)
		{
			//Insert Columns Dynamically.
			for( int i = 0; i < dTable.Columns.Count; i++ )
			{
				ITableColumn col = args.Columns.CreateColumn();
				col.Width = 70;
			}

		}

		int rowCounter = 0;

		private void table_CreateHeaderRow(object sender, CreateRowEventArgs args)
		{
			ITable table = sender as ITable;

			if(headerPublished)
			{
				//Dynamically insert Header Row and format it.
				ITableRow row = table.Rows.CreateRow( false );

				for( int i = 0; i < dTable.Columns.Count; i++ )
				{
					ITableCell cell = row.Cells.CreateCell( dTable.Columns[i].ColumnName );
          
					cell.Style.BackColor = Color.Orange;
					cell.Style.BorderColors.All = Color.Blue;
					cell.Style.BordersWidth.All = 4;
				}
        
				args.Row = row;	
				headerPublished = false;
			}
			
				//Repeat Header for all pages
			else if( table.RepeatHeader )
			{
				headerPublished = true;
			}

		}

		private void table_CreateRow(object sender, CreateRowEventArgs args)
		{
			//Dynamically adding rows.
			if( rowCounter < dTable.Rows.Count)
			{
				ITable table = sender as ITable;

				ITableRow row = table.Rows.CreateRow(false);

				for( int i = 0; i < dTable.Columns.Count; i++ )
				{
					ITableCell cell = row.Cells.CreateCell( dTable.Rows[rowCounter][i].ToString() );
				}
				args.Row = row;

				rowCounter++;
			}			

		}

		private void table_BeforeTablePublishing(object sender, BeforeTablePublishingEventArgs args)
		{
			//Setting Table start Position
			ITable table  = sender as ITable;
			args.Location = new PointF( 0, 10 );
		}
	}
}



